/* The timer (speed throttler) driver for SDL.
   This code is a slightly modified version
   of the code used in FCEU.
*/

#include "../keen.h"
#include <SDL.h>

#include "throttle.h"

typedef char int8;
typedef short int16;   
typedef long  int32;

typedef unsigned char uint8;
typedef unsigned short uint16;   
typedef unsigned long  uint32;

#ifdef __GNUC__
 typedef unsigned long long uint64;
 typedef long long int64;
 #define INLINE inline
 #define GINLINE inline
#elif MSVC
 typedef __int64 int64;
 typedef unsigned __int64 uint64;
 #define INLINE __inline
 #define GINLINE			/* Can't declare a function INLINE
					   and global in MSVC.  Bummer.
					*/
 #define PSS_STYLE 2			/* Does MSVC compile for anything
					   other than Windows/DOS targets?
					*/
#endif

Uint32 FPSCallback(Uint32 interval);

static uint64 tfreq;
static uint64 desiredfps;

void RefreshThrottleFPS(void)
{
//       desiredfps=FCEUI_GetDesiredFPS()>>8;
//        desiredfps = 23000000;
        desiredfps = 21800000;
       tfreq=10000000;
       tfreq<<=16;    /* Adjustment for fps returned from FCEUI_GetDesiredFPS(). */
}

void SpeedThrottle(void)
{
 static uint64 ttime,ltime=0;

 poll_events();

 waiter:
 
 ttime=SDL_GetTicks();
 ttime*=10000;

 if( (ttime-ltime) < (tfreq/desiredfps) )
 {
  int64 delay;
  delay=(tfreq/desiredfps)-(ttime-ltime);
  if(delay>0) 
   SDL_Delay(delay/10000);
  //printf("%d\n",(tfreq/desiredfps)-(ttime-ltime));
  //SDL_Delay((tfreq/desiredfps)-(ttime-ltime));
  goto waiter;
 }
 if( (ttime-ltime) >= (tfreq*4/desiredfps))
  ltime=ttime;
 else
  ltime+=tfreq/desiredfps;
}

char TimeDrv_Start(void)
{
  RefreshThrottleFPS();
  SDL_SetTimer(500, FPSCallback);
  return 0;
}

void TimeDrv_Stop(void)
{
  SDL_SetTimer(0, NULL);
}

Uint32 FPSCallback(Uint32 interval)
{
  fps = (curfps << 1);
  curfps = 0;
  return interval;
}



/*
unsigned int unknownKey;

extern int crashflag;
extern char *why_term_ptr;
extern char fullscreen;

int delayamt = 250;
#define OPTIMAL_FPS             128
#define FPS_GRACE_AMT           5

unsigned long CurrentTickCount = 0;
Uint32 lastCounter = 0;
Uint32 FPSCallback(Uint32 interval);

extern char send_snapshot;

char disable_fps_adjustment = 0;

Uint32 FPSCallback(Uint32 interval)
{
  if (disable_fps_adjustment) return;

  fps = (curfps * 4);
  curfps = 0;

  // adjust timer to try to maintain optimal FPS
  if (fps < OPTIMAL_FPS-FPS_GRACE_AMT)
  {
    if (OPTIMAL_FPS - fps > 50 && delayamt > 10) delayamt -= 10;
    else if (delayamt > 0) delayamt--;
  }
  else if (fps > OPTIMAL_FPS+FPS_GRACE_AMT)
  {
    if (fps - OPTIMAL_FPS > 50 && delayamt < 5000) delayamt += 10;
    else if (delayamt < 5000) delayamt++;
  }

  send_snapshot = 1;

  return interval;
}

char TimeDrv_Start(void)
{
  SDL_SetTimer(250, FPSCallback);
  if (is_server) delayamt = 0;
  else if (is_client && !fullscreen) delayamt = 21;
  else delayamt = 200;
  return 0;
}

void TimeDrv_Stop(void)
{
}


unsigned long TimeDrv_GetTicks(void)
{
  Uint64 pCounterVal;
  Uint32 thisCounter;

   poll_events();

   QueryPerformanceCounter(&pCounterVal);
//   pCounterVal >>= 10;
   pCounterVal >>= 5;
   thisCounter = pCounterVal & 0xffffffff;
   if (thisCounter - lastCounter > delayamt)
   {
     CurrentTickCount = thisCounter;
     lastCounter = thisCounter;
   }

//   return (SDL_GetTicks()>>1);
  return CurrentTickCount;
}

*/
